%global glib_version 2.75.1
%global gtk3_version 3.19.8
%global gtk4_version 4.0.0
%global gsettings_desktop_schemas_version 40
%global json_glib_version 0.12.0
%global libinput_version 1.19.0
%global pipewire_version 0.3.33
%global lcms2_version 2.6
%global colord_version 1.4.5
%global mutter_api_version 12

%global url_ver %%(echo %{version} | cut -d. -f1)

Summary:       Window and compositing manager based on Clutter
Name:          mutter
Version:       44.3
Release:       4%{?dist}
License:       GPLv2+
URL:           http://www.gnome.org
Source0:       http://download.gnome.org/sources/%{name}/%{url_ver}/%{name}-%{version}.tar.xz

Patch3000:     0001-window-actor-Special-case-shaped-Java-windows.patch
Patch3001:     mutter-42.alpha-disable-tegra.patch

BuildRequires: pkgconfig(gobject-introspection-1.0) >= 1.41.0
BuildRequires: pkgconfig(sm) pkgconfig(libwacom)
BuildRequires: xorg-x11-server-Xorg xorg-x11-server-Xvfb desktop-file-utils
BuildRequires: pkgconfig(x11) pkgconfig(xdamage) pkgconfig(xext)
BuildRequires: pkgconfig(xfixes) pkgconfig(xi) pkgconfig(xrandr)
BuildRequires: pkgconfig(xrender) pkgconfig(xcursor) pkgconfig(xcomposite)
BuildRequires: pkgconfig(x11-xcb) pkgconfig(xkbcommon) pkgconfig(xkbcommon-x11)
BuildRequires: pkgconfig(xtst) pkgconfig(xkbfile) pkgconfig(xkeyboard-config)
BuildRequires: mesa-libEGL-devel mesa-libGLES-devel mesa-libGL-devel mesa-libgbm-devel
BuildRequires: pkgconfig(glesv2) pkgconfig(graphene-gobject-1.0)
BuildRequires: pkgconfig(libpipewire-0.3) >= %{pipewire_version}
BuildRequires: pkgconfig(sysprof-capture-4) sysprof-devel
BuildRequires: pkgconfig(libsystemd) pam-devel zenity cvt
BuildRequires: gettext-devel git-core meson
BuildRequires: pkgconfig(gsettings-desktop-schemas) >= %{gsettings_desktop_schemas_version}
BuildRequires: pkgconfig(gnome-settings-daemon) pkgconfig(gnome-desktop-4)
BuildRequires: pkgconfig(gbm) pkgconfig(gudev-1.0) pkgconfig(libdrm) pkgconfig(libcanberra)
BuildRequires: pkgconfig(wayland-eglstream) pkgconfig(wayland-protocols) pkgconfig(wayland-server) pkgconfig(xwayland)
BuildRequires: pkgconfig(libstartup-notification-1.0)
BuildRequires: pkgconfig(lcms2) >= %{lcms2_version}
BuildRequires: pkgconfig(colord) >= %{colord_version}
BuildRequires: pkgconfig(json-glib-1.0) >= %{json_glib_version}
BuildRequires: pkgconfig(libinput) >= %{libinput_version}

Requires:      control-center-filesystem
Requires:      gnome-settings-daemon
Requires:      gsettings-desktop-schemas >= %{gsettings_desktop_schemas_version}
Requires:      gtk3 >= %{gtk3_version}
Requires:      gtk4 >= %{gtk4_version}
Requires:      json-glib >= %{json_glib_version}
Requires:      libinput >= %{libinput_version}
Requires:      pipewire >= %{pipewire_version}
Requires:      startup-notification dbus zenity
Recommends:    mesa-dri-drivers

Provides: firstboot(windowmanager) = mutter
Provides: bundled(cogl) = 1.22.0
Provides: bundled(clutter) = 1.26.0

%description
Mutter is a window and compositing manager that displays and manages
your desktop via OpenGL. Mutter combines a sophisticated display engine
using the Clutter toolkit with solid window-management logic inherited
from the Metacity window manager.

While Mutter can be used stand-alone, it is primarily intended to be
used as the display core of a larger system such as GNOME Shell. For
this reason, Mutter is very extensible via plugins, which are used both
to add fancy visual effects and to rework the window management
behaviors to meet the needs of the environment.

%package devel
Summary: Development package for %{name}
Requires: %{name} = %{version}-%{release}
Requires: mesa-libEGL-devel

%description devel
Header files and libraries for developing Mutter plugins. Also includes
utilities for testing Metacity/Mutter themes.


%package  tests
Summary:  Tests for the %{name} package
Requires: %{name} = %{version}-%{release}

%description tests
The %{name}-tests package contains tests that can be used to verify
the functionality of the installed %{name} package.


%prep
%autosetup -S git -n %{name}-%{version}


%build
%meson -Degl_device=true -Dwayland_eglstream=true
%meson_build


%install
%meson_install
%find_lang %{name}


%files -f %{name}.lang
%license COPYING
%doc NEWS
%{_bindir}/mutter
%{_libdir}/lib*.so.*
%{_libdir}/mutter-%{mutter_api_version}/
%{_libexecdir}/mutter-restart-helper
%{_libexecdir}/mutter-x11-frames
%{_datadir}/GConf/gsettings/mutter-schemas.convert
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.wayland.gschema.xml
%{_datadir}/gnome-control-center/keybindings/50-mutter-*.xml
%{_mandir}/man1/mutter.1*
%{_udevrulesdir}/61-mutter.rules


%files devel
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*


%files tests
%{_libexecdir}/installed-tests/mutter-%{mutter_api_version}
%{_datadir}/installed-tests/mutter-%{mutter_api_version}
%{_datadir}/mutter-%{mutter_api_version}/tests


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 44.3-4
- Rebuilt for loongarch release

* Tue Nov 21 2023 cunshunxia@tencent.com - 44.3-3
- Rebuilt for pipewire 0.3.85

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 44.3-2
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 22 2023 Shuo Wang <abushwang@tencent.com> - 44.3-1
- update to 44.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 43.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 43.1-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Dec 2 2022 rockerzhu <rockerzhu@tencent.com> - 43.1-1
- Initial build
